var assert = require('assert');
var hub = require('./Hub.js');
var node = require('./Node.js');

var socketio = require('socket.io');

describe('Hub', function() {
    describe('#Constructor', function() {
        it('uuid should be a unique ID', function() {
            var testHub = new hub.Hub();
            assert.equal(testHub.uuidValid(),true);
        });

        it('activeConnections should be an empty dict', function() {
            var testHub = new hub.Hub();
            assert.equal(testHub.activeConnsEmpty(),true);
        });
    });

    describe('#ActiveConnections', function() {
        it('test ability to add things to Active Connections', function() {
            var testHub = new hub.Hub();
            var testNode = new node.Node(123412, '1.2.3.4', '#DEADBEEF', 'mainHub', testNode);

            testHub.addActiveConn('one', 'alsdjf;alksdjfa;lsjdfal;j');
            testHub.addActiveConn('sentence', 'The quick brown fox jumped over the brown dog');
            testHub.addActiveConn(testNode.getUuid, testNode);
            assert.equal(testHub.activeConnsEmpty(),false);
        });

        it('test ability to remove things from Active Connections', function() {
            var testHub = new hub.Hub();
            var testNode = new node.Node(123412, '1.2.3.4', '#DEADBEEF', 'mainHub', testNode);

            testHub.removeActiveConn(5);

            testHub.addActiveConn('one', 'alsdjf;alksdjfa;lsjdfal;j');
            testHub.addActiveConn('sentence', 'The quick brown fox jumped over the brown dog');
            testHub.addActiveConn(testNode.getUuid(), testNode);

            assert.equal(testHub.activeConnsEmpty(),false);
            testHub.removeActiveConn('one');
            testHub.removeActiveConn('sentence');
            testHub.removeActiveConn(testNode.getUuid());
            assert.equal(testHub.activeConnsEmpty(),true);
        });

    });

    describe('#Ping', function() {
        it('test ability to pingAll() activeConnections', function() {
            var testHub = new hub.Hub();
            testHub.addActiveConn('one', 'alsdjf;alksdjfa;lsjdfal;j');
            testHub.addActiveConn('sentence', 'The quick brown fox jumped over the brown dog');
            //TODO: implement some psuedo sockets or something so I can test multicasting
            assert.equal(true,false);
        });
    });
});

describe('MainHub', function() {
    describe('#Constructor', function() {
        it('uuid should be a unique ID', function() {
            var testHub = new hub.MainHub();
            assert.equal(testHub.uuidValid(),true);
        });

        it('activeConnections should be an empty dict', function() {
            var testHub = new hub.Hub();
            assert.equal(testHub.activeConnsEmpty(),true);
        });
    });
});

describe('AuxHub', function() {
    describe('#Constructor', function() {
        it('uuid should be a unique ID', function() {
            var testHub = new hub.AuxHub();
            assert.equal(testHub.uuidValid(),true);
        });

        it('activeConnections should be an empty dict', function() {
            var testHub = new hub.Hub();
            assert.equal(testHub.activeConnsEmpty(),true);
        });
    });

    describe('#Crawlers', function() {
        it('test ability to sucessfully call a crawler', function() {
            var testHub = new hub.AuxHub();
            //TODO: set up a psuedo crawler to avoid overusing API

            assert.equal(false,true);
        });

        it('test ability to recieve and chache data from crawler', function() {
            var testHub = new hub.Hub();

            //TODO: set up a psuedo crawler to avoid overusing API, decide how i'd like to cache data temp.

            assert.equal(false,true);
        });
    });

    describe('#Communcation', function() {
        it('test ability to alert dispatcher that we have recieved a request and will complete it', function() {
            var testHub = new hub.AuxHub();
            //TODO: set up some sockets or some such to simulate ability to communicate

            assert.equal(false,true);
        });

        it('test ability to send data back to dispatcher', function() {
            var testHub = new hub.Hub();

            //TODO: set up some sockets or some such to simulate ability to communicate

            assert.equal(false,true);
        });
    });
});
