var mysql = require('mysql');

class MySqlConnector{
    constructor(hub) {
        var currentHub = hub;
        var con = mysql.createConnection({
            host: "euclid.nmu.edu",
            user: "kylodden",
            password: "1234aAa4321",
            database: "SeniorProjectHubs",
            timeout: 5000
        });

        var con2 = mysql.createConnection({
            host: "euclid.nmu.edu",
            user: "kylodden",
            password: "1234aAa4321",
            database: "SeniorProjectSaves",
            timeout: 5000
        });

        con2.connect(function (err) {
            if(err) throw err;
            console.log("Connected to SeniorProjectSaves database successfully");
        });

        con.connect(function (err) {
            if (err) throw err;
            console.log("Connected to SeniorProjectHubs database successfully.");
        });

        function parseIntoArray(results, hub, callback){
            var finalArray = [];
            results.forEach(function(element){
                finalArray.push([element.uuid, element.ip])
            });

            callback.call(currentHub.state,finalArray);
        }

        this.activeConnections = function activeConnections(hub, callback) {

            var sql = "select * from knownHubs order by uuid;";
            console.log("Retrieving known active hubs");

            return con.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;
                var activeConns = result;
                parseIntoArray(activeConns, hub, callback);
            });
        };

        this.activeMainHub = function activeMainHub(hub, callback) {

            var sql = "select * from mainHubs order by uuid";
            console.log("Retrieving known main hub");

            con.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;
                var mainHub = result;
                parseIntoArray(mainHub, hub,callback);
            });
        };


        this.addMainHub = function addMainHub(uuid, ip){
            var sql = "Insert Into mainHubs (uuid, ip) values ('"+uuid.toString()+"', '"+ip.toString()+"');";

            con.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;
            });
        };

        this.addActiveConn = function addActiveConn(uuid, ip, callback){
            var sql = "Insert Into knownHubs (uuid, ip) values ('"+uuid.toString()+"', '"+ip.toString()+"');";

            con.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;

                callback.call(currentHub.state)
            });

        };

        this.removeActiveConn = function(uuid){
            var sql = "delete from knownHubs where uuid ='"+uuid.toString()+"';";

            con.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;

            });
        };

        this.removeMainConn = function(uuid){
            var sql = "delete from mainHubs where uuid ='"+uuid.toString()+"';";

            con.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;

            });
        };
        
        this.save = function (mobileID,term,data) {
            //TODO: add to the db
            var sql = 'delete from saves where id='+mysql.escape(mobileID.toString())+';';

            con2.query({sql: sql, timeout: 5000}, function (err, result) {
                var sql2 = 'insert Into saves (id, name, artText, artPic, artVid) values ("'+mysql.escape(mobileID.toString())+'", "'+mysql.escape(term.toString())+'", "'+mysql.escape(data[0].toString())+'", "'+mysql.escape(data[1].toString())+'", "'+mysql.escape(data[2].toString())+'");';

                con2.query({sql: sql2, timeout: 5000}, function (err, result) {
                    if (err) throw err;

                    console.log("saved " + term + " for " + mobileID);
                });
            });
        };

        this.loadArt = function (mobileID,term) {
            var sql = 'select artText, artPic, artVid from saves where id="'+mysql.escape(mobileID.toString())+'" and name="'+mysql.escape(term.toString())+'";';
            var retVal = [];

            con2.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;
                retVal[0] = result[0].artText;
                retVal[1] = result[0].artPic;
                retVal[2] = result[0].artVid;
                hub.server.sendSearchResults(retVal, mobileID)
            });
        };

        this.loadList = function(mobileID){
            var sql = 'select name from saves where id="'+mysql.escape(mobileID.toString())+'";';
            var retVal = [];

            con2.query({sql: sql, timeout: 5000}, function (err, result) {
                if (err) throw err;
                console.log(result.length + " saves found for " + mobileID);
                result.forEach(function (element) {
                    retVal.push(element.name.replace(/'/g, ""))
                });
                hub.state.loadedList(mobileID, retVal)
            });

        };

        return this;
    }

}

module.exports.MySqlConnector = MySqlConnector;