const io = require('socket.io-client');

class SocketIOClient{
    constructor(hub,ip) {
        this.hub = hub;
        var connectAttempts = 0;
        console.log("launching socketIO client...")
        var socket = io('http://'+ip+':4321/auxHub', {timeout: 1000, reconnectionDelayMax: 1000,randomizationFactor: .5});

        socket.on("checkIfAux", function () {
            socket.emit('isAux');
        });

        socket.on('connect_timeout', function () {
            console.log("Failed to connect to main hub(timeout)...");
            connectAttempts += 1;
            if(connectAttempts >= 5){
                connectAttempts = 0;
                console.log("Failed to connect to main hub, assuming down status...")
                hub.state.handleTimouts();
                socket.close();
            }
        });

         //For some reason linux does not care for connect timeout
        socket.on('connect_error', function () {
            console.log("Failed to connect to main hub(timeout)...");
            connectAttempts += 1;
            if(connectAttempts >= 5){
                connectAttempts = 0;
                console.log("Failed to connect to main hub, assuming down status...")
                hub.state.handleTimouts();
                socket.close();
            }
        });

        socket.on('disconnect', function(){
            console.log("Lost connection to main hub");
        });

        socket.on('requestUUID',function(){
            socket.emit('recieveUUID', hub.uuid);
        });

        socket.on('crawlFor', function(data, IDs){
            hub.runCrawl(data, IDs);
        });

        this.returnResults = function(data, IDs){
            socket.emit('recieveCrawlResult', data, IDs);
        };

        return this;
    }

}

module.exports.SocketIOClient = SocketIOClient;