package edu.nmu.kylodden.seniorprojectapp

import android.Manifest
import android.app.Activity
import android.content.Context
import android.content.Context.MODE_PRIVATE
import android.content.SharedPreferences
import android.content.pm.PackageManager
import android.net.Uri
import android.os.Bundle
import android.os.Environment
import android.os.Looper
import android.os.StrictMode
import android.support.design.widget.BottomNavigationView
import android.support.v4.content.ContextCompat
import android.support.v7.app.AlertDialog
import android.support.v7.app.AppCompatActivity
import android.text.Html
import android.widget.TextView
import kotlinx.android.synthetic.main.activity_main_screen.*
import android.view.View
import android.view.ViewGroup
import android.webkit.WebSettings
import android.webkit.WebView
import android.widget.Button
import android.widget.EditText
import android.widget.ImageView
import com.beust.klaxon.Klaxon
import io.socket.client.IO
import io.socket.client.Socket
import java.net.URI
import io.socket.emitter.Emitter
import io.socket.client.Socket.EVENT_DISCONNECT
import io.socket.client.Socket.EVENT_CONNECT
import org.jsoup.Jsoup
import java.io.*
import java.lang.System.out
import java.net.UnknownHostException
import java.util.*
import kotlin.reflect.jvm.internal.impl.renderer.RenderingFormat


class MainScreen : AppCompatActivity() {

    var uuid = ""
    var mainHub: String? = ""
    var socket = IO.socket("http://35.24.131.40:4321/mobile")
    var savesList :Array<String> = arrayOf<String>()
    var article :Article? = Article("\"The quick brown fox jumped over the small brown dog. Also other stuff to see if text wraps\"","<img src=\"https://i.ytimg.com/vi/SfLV8hD7zX4/maxresdefault.jpg\" alt=\"I'm a picture!\">","<iframe width=\"560\" height=\"315\" src=\"https://www.youtube.com/embed/QxJrjV4PNXA\" frameborder=\"0\" allow=\"autoplay; encrypted-media\" allowfullscreen></iframe>")

    private val mOnNavigationItemSelectedListener = BottomNavigationView.OnNavigationItemSelectedListener { item ->
        when (item.itemId) {
            R.id.navigation_home -> {
                clearLinearLayout()
                pageTitle.setText(R.string.title_home)
                populateHomeView()
                return@OnNavigationItemSelectedListener true
            }
            R.id.navigation_article -> {
                clearLinearLayout()
                pageTitle.setText(R.string.title_article)
                clearLinearLayout()
                populateArticleView()

                return@OnNavigationItemSelectedListener true
            }
            R.id.navigation_saves -> {
                clearLinearLayout()
                pageTitle.setText(R.string.title_saves)
                populateSavesView()
                return@OnNavigationItemSelectedListener true
            }
        }
        false
    }

    private fun populateArticleView(){
        //TODO: get stuff we have from database

        //loads image for article
        val articleWebView = WebView(this)
        articleWebView.loadData(article?.pic, "text/html", null)

        //Displays text from article
        val articleTextWebView = WebView(this)
        articleTextWebView.loadData(article?.text, "text/html", null)

        //Displays link for video
        val videoWebView = WebView(this)
        videoWebView.settings.javaScriptEnabled = true
        videoWebView.loadData(article?.vid,"text/html", null)

        //add button to save
        val customSaveButton = Button(this)
        customSaveButton.text = getString(R.string.SaveButtonText)
        customSaveButton.setOnClickListener(View.OnClickListener {
            requestSave()
        })

        //add views to layout to display
        articleLinearLayout.addView(articleWebView)
        articleLinearLayout.addView(articleTextWebView)
        articleLinearLayout.addView(videoWebView)
        articleLinearLayout.addView(customSaveButton)

    }

    private fun populateHomeView(){
        val homePromptTextView = TextView(this)
        homePromptTextView.text = getString(R.string.searchPrompt)

        val homeTextEdit = EditText(this)
        homeTextEdit.inputType = 1 //plain text
        homeTextEdit.setText("Dogs")


        val customHomeSearchButton = Button(this)
        customHomeSearchButton.text = getString(R.string.myButtonText)
        customHomeSearchButton.setOnClickListener(View.OnClickListener {
            dispatchSearch(homeTextEdit.text)
        })

        val disclaimerTextView = TextView(this)
        disclaimerTextView.text = getString(R.string.disclaimerText)

        val uuidTextView = TextView(this)
        uuidTextView.text = uuid

        articleLinearLayout.addView(homePromptTextView)
        articleLinearLayout.addView(homeTextEdit)
        articleLinearLayout.addView(customHomeSearchButton)
        articleLinearLayout.addView(disclaimerTextView)
        articleLinearLayout.addView(uuidTextView)
    }

    private fun populateSavesView(){
        for(save in savesList){
            val saveAccessButton = Button(this)
            saveAccessButton.text = save
            saveAccessButton.setOnClickListener(View.OnClickListener {
                val text = saveAccessButton.text
                getSave(text.toString())
            })
            articleLinearLayout.addView(saveAccessButton)
        }

        val saveRefreshButton = Button(this)
        saveRefreshButton.text = getString(R.string.refreshSaveButtonText)
        saveRefreshButton.setOnClickListener(View.OnClickListener {
            //TODO: insert actual uuid
            socket.emit("receiveLoadListRequest", uuid)
        })
        articleLinearLayout.addView(saveRefreshButton)

    }


    private fun dispatchSearch(searchText: Any){
        val ab = AlertDialog.Builder(this)

        ab.setTitle("")
        ab.setMessage("Search Initiated for $searchText")
        val dialouge = ab.create()
        dialouge.show()
        socket.emit("recieveSearchRequest", searchText, uuid)
    }

    private fun clearLinearLayout(){
        var children = articleLinearLayout.childCount
        if (children >= 1)
            for (i in 0..children) articleLinearLayout.removeView(articleLinearLayout.getChildAt(0))
    }

    private fun requestSave(){
        //TODO: insert acutal uuid
        socket.emit("receiveSaveRequest", uuid)

        val ab = AlertDialog.Builder(this)

        ab.setTitle("")
        ab.setMessage("Sent Request to Permanently Store Article")
        val dialouge = ab.create()
        dialouge.show()
    }

    private fun getSave(term: String){
        socket.emit("receiveLoadArt", uuid, term)
    }

    private fun formatSearchResults(res: Array<Any>){
        val result = Klaxon().parse<Article>(res[0].toString())
        article = result
        val ab = AlertDialog.Builder(this)
        ab.setTitle("")
        ab.setMessage("Search Results Received")
        val dialouge = ab.create()
        dialouge.show()
    }

    private fun formatSaveList(res: Array<Any>){
        val results = Klaxon().parseArray<String>(res[0].toString())
        savesList = results!!.toTypedArray()

        val ab = AlertDialog.Builder(this)
        ab.setTitle("")
        ab.setMessage("Saved Articles List Refreshed")
        val dialouge = ab.create()
        dialouge.show()
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main_screen)

        var policy = StrictMode.ThreadPolicy.Builder().permitAll().build()
        StrictMode.setThreadPolicy(policy)

        this.runOnUiThread(java.lang.Runnable {
            mainHub = getMainHub()
        })

        val prefs = this.getSharedPreferences("UUID", 0)
        val loadedUUID = prefs!!.getString("UUID", UUID.randomUUID().toString())

        val editor = prefs!!.edit()
        editor.putString("UUID", loadedUUID)
        editor.apply()

        uuid = loadedUUID

        socket = IO.socket("http://"+mainHub+":4321/mobile")
        socket.connect()
        socket.emit("receiveUUID", uuid)
        setSocketListeners()

        navigation.setOnNavigationItemSelectedListener(mOnNavigationItemSelectedListener)
        populateHomeView()
    }

    fun newSocket(){
        socket.close()
        socket = IO.socket("http://"+mainHub+":4321/mobile")
        socket.connect()
        socket.emit("receiveUUID", uuid)
        setSocketListeners()
    }

    fun setSocketListeners(){
        socket.on("returnSearchResults", Emitter.Listener() {
            this.runOnUiThread(java.lang.Runnable {
                formatSearchResults(it)
            })
        })

        socket.on("connection_error", Emitter.Listener() {
            this.runOnUiThread(java.lang.Runnable {
                mainHub = getMainHub()
            })
        })

        socket.on("returnSaveList", Emitter.Listener() {
            this.runOnUiThread(java.lang.Runnable {
                formatSaveList(it)
            })
        })

        socket.on("reconnect_attempt", Emitter.Listener() {
            mainHub = getMainHub()
            newSocket()
        })
    }
}



fun getMainHub(): String? {
    try {
        var mainHub = Jsoup.connect("http://euclid.nmu.edu/~kylodden/SeniorProject/MainHub.php").get()
        var ip = mainHub.select("body").text()
        return ip
    }
    catch (error: UnknownHostException){
        //no internet connection
        return ""
    }
}

class Article(
        val text: String, val pic: String, val vid: String
)
